<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Flickr Plugin 1.0                                                         |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// |                                                                           |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API methods and 2) implements all the common code needed by this plugin.  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun        - dirk AT haun-online DOT de                    |
// |          ::Ben              http://geeklog.fr                             |
// |          Felipe Skroski     http://www.felipesk.com                       |
// +---------------------------------------------------------------------------+
// | Created with the Geeklog Plugin Toolkit.                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package Flickr
*/

if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.inc') !== false) {
    die ('This file can not be used on its own.');
}

// This is the Flickr API key for the Geeklog Flickr plugin.
// Should you create any derived work from this plugin, please get your own
// API key (it's free) from http://www.flickr.com/services/api/
define ('FLICKR_API_KEY', '8b172ed890f21a3e28d11d30903bfc49');

/**
 * Language file include
 */
$plugin_path = $_CONF['path'] . 'plugins/flickr/';
$langfile = $plugin_path . 'language/' . $_CONF['language'] . '.php';

if (file_exists($langfile)) {
    require_once $langfile;
} else {
    require_once $plugin_path . 'language/english.php';
}
/**
 * Flickr plugin table(s)
 */
$_TABLES['flickr_cache'] = $_DB_table_prefix . 'flickr_cache';

/**
 * Load our config
 */
require_once $_CONF['path_system'].'classes/config.class.php';
$c = config::get_instance();
$_FL_CONF = $c->get_config('flickr');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementation                                         |
// +---------------------------------------------------------------------------+


/**
* Implements autotags
*
* @param    string  $op         operation to perform
* @param    string  $content    item (e.g. story text), including the autotag
* @param    array   $autotag    parameters used in the autotag
* @param    mixed               tag names (for $op='tagname') or formatted content
*
*/

function plugin_autotags_flickr ($op, $content = '', $autotag = '')
{
    global $_CONF, $_FL_CONF, $_DB_host, $_DB_name, $_DB_user, $_DB_pass;

    if ($op == 'tagname') {

        return array('flickr', 'flickr_gallery', 'flickr_slideshow');

    } else if ($op == 'parse') {

        static $flickr;

        require_once ($_CONF['path'] . 'plugins/flickr/include/phpFlickr.php');

        if (!isset ($flickr)) {
            $flickr = new phpFlickr (FLICKR_API_KEY, NULL, false);

            if ($_FL_CONF['use_cache']) {
                if ($_FL_CONF['cache_type'] == 'db') {
                    $flickr->enableCache ('db',
                            "mysql://$_DB_user:$_DB_pass@$_DB_host/$_DB_name",
                            $_FL_CONF['cache_expiration'],
                            $_FL_CONF['cache_table_name']);
                } else {
                    // phpFlickr prefers its paths without a trailing slash
                    if (substr ($_FL_CONF['cache_fs_name'], -1) == '/') {
                        $_FL_CONF['cache_fs_name']
                                = substr ($_FL_CONF['cache_fs_name'], 0, -1);
                    }
                    $flickr->enableCache ('fs', $_FL_CONF['cache_fs_name'],
                                          $_FL_CONF['cache_expiration']);
                }
            }
        }
	
				$caption = $autotag['parm2'];
				$skip = 0;

				$px = explode (' ', trim ($autotag['parm2']));
				if (is_array ($px)) {
					foreach ($px as $part) {
						if (substr ($part, 0, 8) == 'user_id:') {
							$a = explode (':', $part);
							$user_id = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 5) == 'tags:') {
							$a = explode (':', $part);
							$tags = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 16) == 'min_upload_date:') {
							$a = explode (':', $part);
							$min_upload_date = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 16) == 'max_upload_date:') {
							$a = explode(':', $part);
							$max_upload_date = $a[1];
							$skip++;
							$aSet = 1;
						} elseif (substr($part, 0, 5) == 'sort:') {
							$a = explode(':', $part);
							$sort = $a[1];
							$skip++;
						} elseif (substr($part, 0, 5) == 'bbox:') {
							$a = explode(':', $part);
							$bbox = $a[1];
							$skip++;
						} elseif (substr($part, 0, 12) == 'safe_search:') {
							$a = explode(':',$part);
							$safe_search = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 13) == 'content_type:') {
							$a = explode (':', $part);
							$content_type = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 9) == 'group_id:') {
							$a = explode (':', $part);
							$group_id = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 4) == 'lat:' ) {
							$a = explode (':',$part);
							$slat = $a[1];
							$skip++;
						} elseif (substr ($part, 0, 4) == 'lon:') {
							$a = explode (':', $part);
							$lon = $a[1];
							$skip++;
						} elseif ( substr($part, 0, 13) == 'radius_units:' ) {
							$a = explode (':',$part);
							$radius_units = $a[1];
							$skip++;
						} elseif ( substr($part, 0, 7) == 'set_id:' ) {
							$a = explode (':',$part);
							$set_id = $a[1];
							$skip++;
						} else {
							break;
						}
					}
					if ($skip != 0) {
						if (count ($px) > $skip) {
							for ($i = 0; $i < $skip; $i++) {
								array_shift ($px);
							}
							$caption = trim (implode (' ', $px));
						} else {
							$caption = '';
						}
					} else {
						$caption = trim ($autotag['parm2']);
					}
				}
					
		switch( $autotag['tag'] ) {
            case 'flickr' :

				$id = $autotag['parm1'];
				$title = '';

				$photoalign = '';           // default alignment: none
				$photosize = 'Thumbnail';   // default photo size
				if (!empty ($autotag['parm2'])) {
					$skip = 0;
					$px = explode (' ', trim ($autotag['parm2']));
					if (is_array ($px)) {
						foreach ($px as $part) {
							if (substr ($part, 0, 6) == 'align:') {
								$a = explode (':', $part);
								$a = strtolower ($a[1]);
								if (($a == 'left') || ($a == 'right')) {
									$photoalign='align="' . $a . '" ';
								}
								$skip++;
							} else if (substr ($part, 0, 5) == 'size:') {
								$s = explode (':', $part);
								$s = strtolower ($s[1]);
								if (($s == 'square') || ($s == 'thumbnail') ||
										($s == 'small') || ($s == 'medium')) {
									$photosize = ucwords ($s);
								}
								$skip++;
							} else {
								break;
							}
						}
						if ($skip == 0) {
							$title = trim ($autotag['parm2']);
						} else {
							if (count ($px) > $skip) {
								for ($i = 0; $i < $skip; $i++) {
									array_shift ($px);
								}
								$title = trim (implode (' ', $px));
							}
						}
					} else {
						$title = trim ($autotag['parm2']);
					}
				}

				$thumbnail = '';
				$photopage = '';

				$info = $flickr->photos_getInfo ($id);

				if (empty ($title) && !empty ($info['title'])) {
					$title = $info['title'];
				}

				$urls = $info['urls']['url'];
				if (is_array ($urls)) {
					foreach ($urls as $url) {
						if ($url['type'] == 'photopage') {
							$photopage = $url['_value'];
							break;
						}
					}
				}

				if (!empty ($photopage)) {
					$sizes = $flickr->photos_getSizes ($id);

					foreach ($sizes as $size) {
						if ($size['label'] == $photosize) {
							$thumbnail = '<img src="' . $size['source'] . '" width="'
								. $size['width'] . '" height="' . $size['height'] . '" '
								. 'border="0" ' . $photoalign . 'alt="' . $title
								. '" title="' . $title . '" class="flickr-photo">';
							break;
						}
					}
				}

				if (!empty ($thumbnail) && !empty ($photopage)) {
					$piclink = '<a href="' . $photopage . '">' . $thumbnail . '</a>';
					$content = str_replace ($autotag['tagstr'], $piclink, $content);
				}
				return $content;
				break;
				
			case 'flickr_gallery' :
				//builds the gallery
				$div_content = 'Loading... flickr gallery';
				$per_page = $autotag['parm1'];
				if ($per_page > 500) {
				    $per_page = 500;
				}
				$link = '';
					
				$gallery_content = "<div class=\"flickr-mini-gallery\" rel=\"user_id={$user_id}&tags={$tags}&min_upload_date={$min_upload_date}&max_upload_date={$max_upload_date}&min_taken_date={$min_taken_date}&max_taken_date={$max_taken_date}&sort={$sort}&bbox={$bbox}&safe_search={$safe_search}&content_type={$content_type}&group_id={$group_id}&lat={$lat}&lon={$lon}&radius_units={$radius_units}&per_page={$per_page}\">{$div_content}</div><p>{$caption}</p>";
				$content = str_replace ($autotag['tagstr'], $gallery_content, $content);
				return $content;
				break;
			
			case 'flickr_slideshow' :
			    //builds the slideshow
				$user_id = $autotag['parm1'];
				if ($set_id == ''){
				$slideshow = "<object width=\"400\" height=\"300\"> <param name=\"flashvars\" value=\"offsite=true&page_show_url=%2Fphotos%2F{$user_id}%2Fshow%2F&page_show_back_url=%2Fphotos%2{$user_id}%2F&user_id={$user_id}\"></param> <param name=\"movie\" value=\"http://www.flickr.com/apps/slideshow/show.swf?v=71649\"></param> <param name=\"allowFullScreen\" value=\"true\"></param><embed type=\"application/x-shockwave-flash\" src=\"http://www.flickr.com/apps/slideshow/show.swf?v=71649\" allowFullScreen=\"true\" flashvars=\"offsite=true&page_show_url=%2Fphotos%2F{$user_id}%2Fshow%2F&page_show_back_url=%2Fphotos%2F{$user_id}%2F&user_id={$user_id}\" width=\"400\" height=\"300\"></embed></object>";
				} else {
				$slideshow  = "<object width=\"400\" height=\"300\"> <param name=\"flashvars\" value=\"offsite=true&page_show_url=%2Fphotos%2F{$user_id}%2Fsets%2F{$set_id}%2Fshow%2F&page_show_back_url=%2Fphotos%2F{$user_id}%2Fsets%2F{$set_id}%2F&set_id={$set_id}\"></param> <param name=\"movie\" value=\"http://www.flickr.com/apps/slideshow/show.swf?v=71649\"></param> <param name=\"allowFullScreen\" value=\"true\"></param><embed type=\"application/x-shockwave-flash\" src=\"http://www.flickr.com/apps/slideshow/show.swf?v=71649\" allowFullScreen=\"true\" flashvars=\"offsite=true&page_show_url=%2Fphotos%2F{$user_id}%2Fsets%2F{$set_id}%2Fshow%2F&page_show_back_url=%2Fphotos%2F{$user_id}%2Fsets%2F{$set_id}%2F&set_id={$set_id}\" width=\"400\" height=\"300\"></embed></object>";
				}
				$content = str_replace ($autotag['tagstr'], $slideshow, $content);
				return $content;
				break;
		}
    }
}


/**
* Return plugin entry for "Command and Control" (moderation.php)
*
* @return  array  Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_flickr()
{
    global $_CONF, $LANG_FLICKR_1;

    $retval = array();
    if (SEC_hasRights('flickr.admin')) {
        $retval = array($LANG_FLICKR_1['plugin_name'],
            $_CONF['site_admin_url'] . '/plugins/flickr/index.php',
            plugin_geticon_flickr());
    }

    return $retval;
}

/**
* Return plugin entry for the Admins Only block
*
* @return array Array containing (plugin name, plugin admin url, # of plugin items or '')
*/
function plugin_getadminoption_flickr()
{
    global $_CONF, $LANG_FLICKR_1;

    if (SEC_hasRights('flickr.admin')) {
        return array($LANG_FLICKR_1['plugin_name'],
            $_CONF['site_admin_url'] . '/plugins/flickr/index.php', 0);
    }
}

/**
* Returns the URL of the plugin's icon
*
* @return   string      URL of the icon
*
*/
function plugin_geticon_flickr()
{
    global $_CONF;

    // popular alternative location:
    // return $_CONF['site_url'] . '/flickr/images/flickr.png';

    return $_CONF['site_admin_url'] . '/plugins/flickr/images/flickr.png';
}

/**
 * Returns the current plugin code version
 *
 * @return string    plugin version
 */
function plugin_chkVersion_flickr()
{
    global $_CONF;

    require_once $_CONF['path'] . 'plugins/flickr/autoinstall.php';

    $inst_parms = plugin_autoinstall_flickr('flickr');

    return $inst_parms['info']['pi_version'];
}

/**
* Update the plugin
*
* @return   int     Number of message to display or true for success
*
*/
function plugin_upgrade_flickr()
{
    global $_CONF, $_TABLES;

    $installed_version = DB_getItem($_TABLES['plugins'], 'pi_version',
                                    "pi_name = 'flickr'");
    $code_version = plugin_chkVersion_flickr();
    if ($installed_version == $code_version) {
        // nothing to do
        return true;
    }

    require_once $_CONF['path'] . 'plugins/flickr/autoinstall.php';

    if (! plugin_compatible_with_this_version_flickr('flickr')) {
        return 3002;
    }

    // other update code goes here

    // update plugin version number
    $inst_parms = plugin_autoinstall_flickr('flickr');
    $pi_gl_version = $inst_parms['info']['pi_gl_version'];

    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version = '$code_version', pi_gl_version = '$pi_gl_version' WHERE pi_name = 'flickr'");
	DB_query("UPDATE {$_TABLES['plugins']} SET pi_homepage = 'http://geeklog.fr' WHERE pi_name = 'flickr'",1);

    return true;
}

/**
* Automatic uninstall function for plugins
*
* This code is automatically uninstalling the plugin.
* It passes an array to the core code function that removes
* tables, groups, features and php blocks from the tables.
* Additionally, this code can perform special actions that cannot be
* foreseen by the core code (interactions with other plugins for example)
*
* @return   array   Plugin information
*
*/
function plugin_autouninstall_flickr()
{
    $out = array (
        /* give the name of the tables, without $_TABLES[] */
        'tables' => array('flickr_cache'),
        /* give the full name of the group, as in the db */
        'groups' => array('Flickr Admin'),
        /* give the full name of the feature, as in the db */
        'features' => array('flickr.admin'),
        /* give the full name of the block, including 'phpblock_', etc */
        'php_blocks' => array(),
        /* give all vars with their name */
        'vars' => array()
    );

    return $out;
}

function plugin_getheadercode_flickr()
{
    global $_CONF, $_FL_CONF;

    // flickr_mini_gallery_img_format = _s for square _t for thumnail
	$str = null;
	$str = LB . LB . '<!-- Begin Flickr plugin http://geeklog.fr Javascript and CSS includes -->'. LB;
    $str .= '<link rel="stylesheet" type="text/css" href="'
        . $_CONF['site_url'] . '/' . $pi_name . 'flickr/css/flickr.css"' . XHTML . '>'. LB;
	
	if(!defined('JQUERY')){
	    if ($_FL_CONF['use_CND'] == true ) {
            $str .= '<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.0/jquery.min.js"></script>'. LB;
        } else {
		    $str .= '<script type="text/javascript" src="' . $_CONF['site_url'] . '/' . $pi_name . 'js/jquery.min.js"></script>'. LB;
		}
		$str .= '<script>
    if(jQueryNoConflict == undefined){
    jQuery.noConflict();
    var jQueryNoConflict = true;
    }
</script>'. LB;

        define('JQUERY', 'true');
    }

	$str .= '<script type="text/javascript">' . LB;
    $str .= '    var theblogurl ="'. $_CONF['site_url'] .'";' . LB;
    $str .= '    var flickr_mini_gallery_img_format ="' . $_FL_CONF['mini_gallery_format'] . '";' . LB;
    $str .= '</script>' . LB;
	if(!defined('JQUERY_LIGHTBOX')){
        $str .= '<script type="text/javascript" src="'
        . $_CONF['site_url'] . '/' . $pi_name . 'flickr/js/jquery.lightbox-0.5.1.js"' . XHTML . '></script>'. LB;
		define('JQUERY_LIGHTBOX', 'true');
		}
	$str .= '<script type="text/javascript" src="'
        . $_CONF['site_url'] . '/' . $pi_name . 'flickr/js/miniflickr-0.1.js"' . XHTML . '></script>'. LB;
	$str .= '<!-- End Flickr plugin includes -->'. LB;

    return $str;
}

?>
