<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Flickr Plugin 1.0                                                         |
// +---------------------------------------------------------------------------+
// | english.php                                                               |
// |                                                                           |
// | English language file                                                     |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2009 by the following authors:                              |
// |                                                                           |
// | Authors: ::Ben                                                            |
// +---------------------------------------------------------------------------+
// | Created with the Geeklog Plugin Toolkit.                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+

/**
* @package Flickr
*/

/**
* Import Geeklog plugin messages for reuse
*
* @global array $LANG32
*/
global $LANG32;

// +---------------------------------------------------------------------------+
// | Array Format:                                                             |
// | $LANGXX[YY]:  $LANG - variable name                                       |
// |               XX    - specific array name                                 |
// |               YY    - phrase id or number                                 |
// +---------------------------------------------------------------------------+

$LANG_FLICKR_1 = array(
    'plugin_name' => 'Flickr',
    'flickr'      => 'flickr, world!', // this is an example only - feel free to remove
	'plugin_doc'  => 'Install, upgrade and usage documentation is',
	'online'      => 'online',
	'plugin_conf' => 'The Flickr plugin configuration is now also'
);

// Localization of the Admin Configuration UI
$LANG_configsections['flickr'] = array(
    'label' => 'flickr',
    'title' => 'flickr Configuration'
);

$LANG_confignames['flickr'] = array(
    'flickrloginrequired' => 'flickr Login Required?',
    'hideflickrmenu'      => 'Hide flickr Menu Entry?',
	'replacefrontpage'    => 'Replace front page',
	'blankpage'           => 'Blank page',
	'profile_hook'        => 'Add flickr to profile',
	'use_cache'           => 'Use cache',
	'cache_type'          => 'Cache type',
	'cache_expiration'    => 'Cache expiration',
	'cache_table_name'    => 'Cache table name',
	'cache_fs_name'       => 'Path to cache files',
	'use_CND'             => 'Use CND for jQuery library',
	'mini_gallery_format' => 'Mini gallery pictures format'

);

$LANG_configsubgroups['flickr'] = array(
    'sg_0' => 'Main'
);

$LANG_fs['flickr'] = array(
    'fs_01' => 'Cache',
    'fs_02' => 'jQuery',
	'fs_03' => 'Theme'
);

// Note: entries 0, 1, and 12 are the same as in $LANG_configselects['Core']
$LANG_configselects['flickr'] = array(
    0  => array('True' => 1, 'False' => 0),
    1  => array('True' => TRUE, 'False' => FALSE),
	21 => array('database' => 'db', 'filesystem' => 'fs'),
    22 => array('square' => '_s', 'thumbnail' => '_t')
);

// Messages for the plugin upgrade
$PLG_flickr_MESSAGE3002 = $LANG32[9]; // "requires a newer version of Geeklog"

?>
